## mingw-w64-texlive-bin-2023.20230523-10.src.tar.zst

=== libs/gd/libgd-src/tests/gdimagecopyresized/CMakeLists.txt ===
IF(PNG_FOUND)
LIST(APPEND TESTS_FILES
	gdimagecopyresized
)
ENDIF(PNG_FOUND)

ADD_GD_TESTS()
